src/backend/protected/modules/news/controllers/CategoriesController.php
<?php
class CategoriesController extends BackendApplicationController 
{
	public $layout = 'application.modules.news.views.layouts.categories';
	public function init()
	{
		parent::init();
		$this->pageTitle = Yii::t("main","Categories Manager");
	}
	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'BackendCategoriesModel'),
		));
	}

	public function actionCreate() {
		$model = new BackendCategoriesModel();


		if (isset($_POST['BackendCategoriesModel'])) {
			$model->attributes = $_POST['BackendCategoriesModel'];
			
			$model->created_by 	= Yii::app()->user->id;
			$model->modified_by = Yii::app()->user->id;
			$model->created = date('Y-m-d H:i:s');
			
			if ($model->save()) {
				if(isset($_POST['BackendCategoriesModel']['file']) && $_POST['BackendCategoriesModel']['file']!=''){
					$filePath = Yii::app()->params['tmp_path'].DS.$_POST['BackendCategoriesModel']['file'];
					if(file_exists($filePath)){
						AvatarHelper::processThumb($model->id, $filePath, 'category');
					}
				}
				Yii::app()->user->setFlash('success','The categories was successfully created.');
				BackendCategoriesModel::updateTree();
				if (Yii::app()->request->isAjaxRequest)
					Yii::app()->end();
				else{
					if($_POST['apply']==1){
						$this->redirect(array('update', 'id' => $model->id));
					}else{
						$this->redirect(array('view', 'id' => $model->id));
					}
				}
			}else{
				Yii::app()->user->setFlash('error','The categories was failed created.');
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'BackendCategoriesModel');

		if (isset($_POST['BackendCategoriesModel'])) {
			$model->attributes = $_POST['BackendCategoriesModel'];
			$model->modified_by = Yii::app()->user->id;
			if ($model->save()) {
				if(isset($_POST['BackendCategoriesModel']['file']) && $_POST['BackendCategoriesModel']['file']!=''){
					$filePath = Yii::app()->params['tmp_path'].DS.$_POST['BackendCategoriesModel']['file'];
					if(file_exists($filePath)){
						AvatarHelper::processThumb($model->id, $filePath, 'category');
					}
				}
				Yii::app()->user->setFlash('success','The categories was successfully updated.');
				BackendCategoriesModel::updateTree();
				if($_POST['apply']==1){
						$this->redirect(array('update', 'id' => $model->id));
					}else{
						$this->redirect(array('view', 'id' => $model->id));
					}
			}else{
				Yii::app()->user->setFlash('error','The categories was failed updated.');
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->request->isPostRequest) {
			$model = $this->loadModel($id, 'BackendCategoriesModel');
			$model->published = BackendCategoriesModel::DELETEED;
			$model->save(false);
			if (!Yii::app()->request->isAjaxRequest)
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('BackendCategoriesModel');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new BackendCategoriesModel('search');
		$model->unsetAttributes();
		if (isset($_GET['BackendCategoriesModel']))
			$model->attributes = $_GET['BackendCategoriesModel'];
		$this->render('admin', array(
			'model' => $model
		));
	}
	public function actionToggle($id,$attribute)
	{
        // we only allow deletion via POST request
        $model = $this->loadModel($id,'BackendCategoriesModel');
        ($model->$attribute==1)?$model->$attribute=0:$model->$attribute=1;
        $model->save();
 
        $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
    }
}

src/backend/protected/modules/news/views/categories/_form.php
<div class="form">
<?php $form = $this->beginWidget('GxActiveForm', array(
	'id' => 'categories-form',
	'enableAjaxValidation' => false,
	'htmlOptions'=>array('enctype'=>'multipart/form-data', 'name'=>'categories-form','class'=>'basic-form inline-form'),
));
?>

	<?php echo $form->errorSummary($model); ?>
	<div class="row">
		<div class="col-md-2">
			<label><?php echo Yii::t('main','Ảnh Thumb')?></label>
		</div>
		<div class="col-md-10">
		<div id="img_tmp" style="margin-bottom: 5px;">
		<img style="border: 1px solid #ccc;" width="200" height="150" onerror="$('#img_tmp').css({'display':'none'})" src="<?php echo ($model->isNewRecord)?Yii::app()->theme->baseUrl."/images/no_image.png":AvatarHelper::getThumbUrl($model->id, "category","sm")?>" />
		</div>
		<?php $this->widget('ext.EAjaxUpload.EAjaxUpload',
			array(
			        'id'=>'uploadFile',
			        'config'=>array(
			               'action'=>Yii::app()->createUrl('/upload/uploadThumb'),
			               'allowedExtensions'=>array("jpg","png"),//array("jpg","jpeg","gif","exe","mov" and etc...
			               'sizeLimit'=>1000*1024*1024,// maximum file size in bytes
			               'minSizeLimit'=>1024,// minimum file size in bytes
			               'onComplete'=>"js:function(id, fileName, responseJSON){ 
			               		if(responseJSON.success==true){
			               			$('#img_tmp img').attr('src','".Yii::app()->params['tmp_url']."/'+responseJSON.filename)
			               			$('#img_tmp').show();
			               			$('#BackendCategoriesModel_file').attr('value',responseJSON.filename);
			               		}else{
			               			console.log(responseJSON);
			               		}
			                }",
			              )
			)); ?>
		</div>
		<?php echo CHtml::hiddenField('BackendCategoriesModel[file]')?>
	</div>
	<div class="row">
		<div class="col-md-2">
			<?php echo $form->labelEx($model,'published'); ?>
		</div>
		<div class="col-md-10">
			<?php echo $form->checkBox($model, 'published',array('class'=>'icheck-blue')); ?>
			<?php echo $form->error($model,'published'); ?>
		</div>
	</div>
	<div class="row">
		<div class="col-md-2">
			<?php echo $form->labelEx($model,'title'); ?>
		</div>
		<div class="col-md-10">
			<?php echo $form->textField($model, 'title', array('maxlength' => 255, 'class'=>'form-control', 'class'=>'txtchange')); ?>
			<?php echo $form->error($model,'title'); ?>
		</div><!-- row -->
	</div>
	<div class="row">
		<div class="col-md-2">
			<?php echo $form->labelEx($model,'alias'); ?>
		</div>
		<div class="col-md-10">
			<?php echo $form->textField($model, 'alias', array('maxlength' => 255, 'class'=>'form-control', 'class'=>'txtrcv')); ?>
			<?php echo $form->error($model,'alias'); ?>
		</div><!-- row -->
	</div>
	<div class="row">
		<div class="col-md-2">
			<?php echo $form->labelEx($model,'parent_id'); ?>
		</div>
		<div class="col-md-10">
			<?php
				$meid = ($model->id!=0)?$model->id:0;
				$cats = BackendCategoriesModel::model()->findAll('published=:p ORDER BY position ASC', array(':p'=>1));
				$listdata = CHtml::listData($cats, 'id', 'title_tree');
				echo '<select name="BackendCategoriesModel[parent_id]" id="BackendCategoriesModel_parent_id">';
				echo '<option value="">--None--</option>';
				foreach($listdata as $key => $cat):
					if($key==$meid){
						echo "<option disabled='disabled'>$cat</option>";
					}else{
						if($model->parent_id==$key){
							$selected = "selected";
						}else{
							$selected="";
						}
						echo "<option value='$key' $selected>$cat</option>";
					}

				endforeach;
				echo '</select>';
			?>
			<?php echo $form->error($model,'parent_id'); ?>
		</div>
	</div><!-- row -->
	<div class="row">
		<div class="col-md-2">
			<?php echo $form->labelEx($model,'description'); ?>
		</div>
		<div class="col-md-10">
			<?php //echo $form->textArea($model, 'description', array('class'=>'textarea-m')); ?>
			<?php //echo $form->error($model,'description'); ?>
            <?php
            $this->widget('ext.imperavi-redactor-widget.ImperaviRedactorWidget', array(
                'model' => $model,
                'attribute' => 'description',
                'options' => array(
                    'buttons'=>array('html','formatting','fontfamily','fontcolor',
                        'bold', 'italic', 'underline', 'deleted','unorderedlist','orderedlist','outdent','indent','link','alignment'
                    ,'horizontalrule','image'
                    ),
                    'lang' => 'en',
                    'imageUpload'=> Yii::app()->createUrl('/upload/fileUpload'),
                    'imageUploadErrorCallback'=>'js:function(json){ alert(json.error); }',
                    //'fileUpload'=>$this->createUrl('fileUpload'),
                    //'fileUploadErrorCallback'=>'js:function(obj, json){ alert(json.error); }',
                    'counterCallback'=>'js:function(data){
						var counter_text = data.words+" words"+", "+data.characters+" characters";
						$("#description_counter").html(counter_text);
						}
					',
                    'imageManagerJson'=>Yii::app()->createUrl('/upload/fileManager'),
                    'minHeight'=>300,
                    'placeholder'=>Yii::t('main','Nhập nội dung')
                ),
                'plugins' => array(
                    'fontfamily'=>array(
                        'js'=>array('fontfamily.js')
                    ),
                    'fontcolor'=>array(
                        'js'=>array('fontcolor.js')
                    ),
                    'fontsize'=>array(
                        'js'=>array('fontsize.js')
                    ),
                    'counter'=>array(
                        'js'=>array('counter.js')
                    ),
                    'cleantext'=>array(
                        'js'=>array('cleantext.js')
                    ),
                    'clips' => array(
                        // You can set base path to assets
                        //'basePath' => 'application.components.imperavi.my_plugin',
                        // or url, basePath will be ignored.
                        // Defaults is url to plugis dir from assets
                        //'baseUrl' => '/js/my_plugin',
                        'css' => array('clips.css',),
                        'js' => array('clips.js',),
                        // add depends packages
                        'depends' => array('imperavi-redactor',),
                    ),
                    'imagemanager' => array(
                        'js' => array('imagemanager.js'),
                    ),
                    'video'=>array(
                        'js'=>array('video.js')
                    ),
                    'table'=>array(
                        'js'=>array('table.js')
                    ),
                    /*'definedlinks'=>array(
                        'js'=>array('definedlinks.js')
                    ),*/
                    'fullscreen' => array(
                        'js' => array('fullscreen.js',),
                    ),
                ),
            ));
            ?>
            <div id="description_counter"></div>
            <?php echo $form->error($model,'description'); ?>
		</div>
	</div><!-- row -->
	<div class="row">
		<div class="col-md-2">
			<?php echo $form->labelEx($model,'ordering'); ?>
		</div>
		<div class="col-md-10">
			<?php echo $form->textField($model, 'ordering', array('style'=>'width: 50px')); ?>
			<?php echo $form->error($model,'ordering'); ?>
		</div>
	</div><!-- row -->
    <div class="row">
		<div class="col-md-2">
			<?php echo $form->labelEx($model,'view'); ?>
		</div>
		<div class="col-md-10">
			<?php echo $form->textField($model, 'view', array('style'=>'width: 100px')); ?>
			<?php echo $form->error($model,'view'); ?>
		</div>
	</div><!-- row -->
	<div class="row">
		<div class="col-md-2">
		<?php echo $form->labelEx($model,'metakey'); ?>
		</div>
		<div class="col-md-10">
		<?php echo $form->textArea($model, 'metakey', array('class'=>'textarea-m')); ?>
		<?php echo $form->error($model,'metakey'); ?>
		</div>
	</div><!-- row -->
	<div class="row">
		<div class="col-md-2">
		<?php echo $form->labelEx($model,'metadesc'); ?>
		</div>
		<div class="col-md-10">
		<?php echo $form->textArea($model, 'metadesc', array('class'=>'textarea-m')); ?>
		<?php echo $form->error($model,'metadesc'); ?>
		</div>
	</div><!-- row -->
	<div class="row">
		<div class="col-md-12">
			<button type="submit" class="btn btn-sm btn-primary" ><i class="fa fa-save"></i>&nbsp;<?php echo Yii::t('main','Save');?></button>
			<button type="button" id="btn_apply" class="btn btn-sm btn-primary" ><i class="fa fa-save"></i>&nbsp;<?php echo Yii::t('main','Save & Continue');?></button>
			<button type="button" onclick="window.location.href='<?php echo Yii::app()->createUrl('/news/categories/admin');?>'" class="btn btn-sm btn-default" ><i class="fa fa-close"></i>&nbsp;<?php echo Yii::t('main','Close');?></button>
		</div>
	</div>
<input type="hidden" name="apply" id="apply" value="0" />
<?php
$this->endWidget();
?>
</div><!-- form -->

src/backend/protected/modules/news/views/categories/_search.php
<div class="wide form">

<?php $form = $this->beginWidget('GxActiveForm', array(
	'action' => Yii::app()->createUrl($this->route),
	'method' => 'get',
	'htmlOptions'=>array('class'=>'basic-form inline-form'),
)); ?>

	<div class="row">
		<div class="col-md-2">
		<?php echo $form->label($model, 'parent_id'); ?>
		</div>
		<div class="col-md-10">
		<?php echo $form->textField($model, 'parent_id'); ?>
		</div>
	</div>

	<div class="row">
		<div class="col-md-2">
		<?php echo $form->label($model, 'title'); ?>
		</div>
		<div class="col-md-10">
		<?php echo $form->textField($model, 'title', array('maxlength' => 255)); ?>
		</div>
	</div>
	<div class="row buttons">
		<?php echo GxHtml::submitButton(Yii::t('app', 'Search'), array('class'=>'btn btn-primary')); ?>
	</div>

<?php $this->endWidget(); ?>

</div><!-- search-form -->

src/backend/protected/modules/news/views/categories/admin.php
<?php
Yii::app()->getModule('news')->setTitle(Yii::t('main','Categories List'));
Yii::app()->clientScript->registerScript('search', "
$('.search-button').click(function(){
	$('.search-form').toggle();
	return false;
});
$('.search-form form').submit(function(){
	$.fn.yiiGridView.update('categories-grid', {
		data: $(this).serialize()
	});
	return false;
});
");
?>

<div class="search-form">
<?php $this->renderPartial('_search', array(
	'model' => $model,
)); ?>
</div><!-- search-form -->
<?php $this->widget('application.widgets.iGridView', array(
	'id' => 'categories-grid',
	'dataProvider' => $model->search(),
	'columns' => array(
		array(
			'header'=>CHtml::checkBox("all",false,array("id"=>"check_all","class"=>"icheck-all")),
			'value'=>'CHtml::checkBox("rad_ID[]",false,array("value"=>$data->id,"class"=>"icheck-blue"))',
			'type'=>'raw'
		),
		array(
			'name'	=>	'title',
			'type'	=>	'raw',
			'value'	=>	'CHtml::link($data->title_tree,array("categories/update","id"=>$data->id))',
		),
		array(
			'name'	=>	'parent_id',
			'value'	=>	'($data->parent_id>0)?BackendCategoriesModel::model()->findByPk($data->parent_id)->title:""'
		),
		array(
			'header' =>Yii::t('app','Articles Number'),
			'value'=>'$data->newsCount',
			'htmlOptions'	=>	array(
				'width'	=>	'100',
				'align'	=>	'center',
			),
		),
		array(
			'name'	=>	'ordering',
			'htmlOptions'=>array(
				'width'	=>	60,
				'align'	=>	'center'
			)
		),
		array(
				'class'=>'JToggleColumn',
				'name'=>'published', // boolean model attribute (tinyint(1) with values 0 or 1)
				'filter' => array('0' => 'No', '1' => 'Yes'), // filter
				'htmlOptions'=>array('width'=>'80','align'=>'center')
		),
		array(
			'name'	=>	'id',
			'htmlOptions'	=>	array(
					'width'	=>	'30',
			)
		),
		array(
			'class'=>'application.widgets.iButtonColumn',
			'htmlOptions'=>array('class'=>'actions'),
		),
	),
)); ?>

src/backend/protected/modules/news/views/categories/create.php
<?php
Yii::app()->getModule('news')->setTitle(Yii::t('main','Thêm mới chủ đề'));
$this->renderPartial('_form', array(
		'model' => $model,
		'buttons' => 'create'));
?>

src/backend/protected/modules/news/views/categories/update.php
<?php
Yii::app()->getModule('news')->setTitle('Sửa chủ đề');
$this->renderPartial('_form', array(
		'model' => $model));
?>

src/backend/protected/modules/news/views/categories/view.php
<?php
Yii::app()->getModule('news')->setTitle('Chi tiết chủ đề');
$this->widget('application.widgets.iDetailView', array(
	'data' => $model,
	'attributes' => array(
'id',
'parent_id',
'level',
'title',
'alias',
'created',
'created_by',
'modified',
'modified_by',
'published:boolean',
	),
)); ?>